import javax.microedition.lcdui.game.*;
import javax.microedition.lcdui.*;
import java.io.InputStream;
import java.io.IOException;

public class AnimationCanvas extends GameCanvas implements Runnable {
    private static final int FRAME_WIDTH = 8;
    private static final int FRAME_HEIGHT = 8;
    private byte level = 1;
    private Sprite man; // Animated sprite
    private LayerManager lmgr; // Manage layers
    private TiledLayer bg;
    private Image bgImg;
    private int px, py;
    private int waid;  //What Am I Doing
    private int whereami, whereami2, whereami3, whereami4, whereami5, whereami6; // где я (две точки - мои ноги) и что у меня внизу 3 4
    private boolean running = false; // Thread running?
    static int[] frameSequenceRun = {0,1,2};
    static int[] frameSequenceLadder = {3,4};
    static int[] frameSequenceFly = {5};
    static int[] frameSequenceClimb = {6,7,8};
    public AnimationCanvas() {
// Gamecanvas constructor

        super(true);
        try {
// Загружаем картинку с фонами
            bgImg = Image.createImage("/bg.png");
// Создаем TiledLayer
            bg = new TiledLayer(30, 30, bgImg, 8, 8);
            //createBg();
            readLevel(level);
// Animated sprite
            man = new Sprite(Image.createImage("/man.png"),
                             FRAME_WIDTH, FRAME_HEIGHT);
// Change the reference pixel to the middle of sprite
            man.defineReferencePixel(FRAME_WIDTH / 2, FRAME_HEIGHT / 2);
            man.setRefPixelPosition(32, 32);
            man.setFrameSequence(frameSequenceRun);
// Layer manager
            lmgr = new LayerManager();
            lmgr.append(bg);
            lmgr.append(man);
        } catch (Exception e) {
            System.out.println("Unable to read PNG image");
        }
    }
    /*--------------------------------------------------
    * Start thread
    *-------------------------------------------------*/
    public void start() {
        running = true;
        waid=1;
        Thread t = new Thread(this);
        t.start();
    }
    /*--------------------------------------------------
    * Main loop
    *-------------------------------------------------*/
    public void run() {
        Graphics g = getGraphics();

        while (running) {
            try {
                Thread.sleep(20);
            } catch (InterruptedException e) {
                ;
            }
            px = man.getX();
            py = man.getY();
            whereami=bg.getCell(px/8, (py+7)/8);
            whereami2=bg.getCell((px+7)/8, (py+7)/8);
            whereami3=bg.getCell(px/8, (py+8)/8);
            whereami4=bg.getCell((px+7)/8, (py+8)/8);
            verifyGameState();
			input();
			drawDisplay(g);
        }
    }

    /*--------------------------------------------------
    * Update display,
    *-------------------------------------------------*/
    private void drawDisplay(Graphics g) {
// Animated sprite, show next frame in sequence
        g.setColor(0x000000);
        g.fillRect(0, 0, getWidth(), getHeight());
        g.setColor(0xFFFFFF);
        g.fillRect(20, 150, 52, 22);
        g.fillRect(20, 200, 80, 22);
        g.setColor(0x000000);
        g.drawString(whereami+" "+whereami2+" "+bg.getCell(px/8, py/8)+" "+bg.getCell((px+7)/8, py/8),20,150,Graphics.LEFT|Graphics.TOP);
        g.drawString(waid+" "+px+" "+py,20,200,Graphics.LEFT|Graphics.TOP);
// Paint layers
        lmgr.paint(g, 0, 0);
// Flush off-screen buffer to display
        flushGraphics();
    }
    /*--------------------------------------------------
    * Stop thread
    *-------------------------------------------------*/
    public void stop() {
        running = false;
    }

    private void input() {
        int keyStates = getKeyStates();
        if ((keyStates & UP_PRESSED) != 0) {
            if (((whereami==4)||(whereami2==4))&&(px%8==0)) {
                if (waid!=2) {
                    man.setFrameSequence(frameSequenceLadder);
                    waid=2;   // Я лезу по лестнице
                }
                whereami5=bg.getCell(px/8, (py-1)/8);
                if ((whereami5!=2)&&(whereami5!=3)) {  // Нет сверху стен то можно лезть
                    man.setPosition(px, py-=1);
                    man.nextFrame();
                }
            } else if ((whereami==4)&&(px%8<4)&&(whereami3!=4)) { // Автоматический заход на лестницу если рядом мы
                if ((keyStates & LEFT_PRESSED) == 0) {
                    man.setPosition(px-=1, py);
                    man.nextFrame();
                }
            } else if ((whereami2==4)&&(px%8>4)&&(whereami4!=4)) {
                if ((keyStates & RIGHT_PRESSED) == 0) {
                    man.setPosition(px+=1, py);
                    man.nextFrame();
                }
            }
        }
        if ((keyStates & DOWN_PRESSED) != 0) {
            if ((whereami3==4)&&(px%8==0)) {
                if (waid!=2) {
                    man.setFrameSequence(frameSequenceLadder);
                    waid=2;   // Я лезу по лестнице					
                }
				man.setPosition(px, py+=1);
				man.nextFrame();
            }
			if ((whereami3==1)&&(whereami4==1)) {				
				waid=0;
				py+=1;
				man.setPosition(px, py);
			}
				
				
        }

        if (((keyStates & LEFT_PRESSED) != 0)&&(waid!=3)&&(py%8==0)) {  // Выход за пределы лестницы только по блокам 8*8
            whereami5=bg.getCell((px-1)/8, py/8);
            whereami6=bg.getCell((px-1)/8, (py+7)/8);

            if ((waid!=1)&&(waid!=4)) {
                man.setFrameSequence(frameSequenceRun);
                waid = 1; // Я бегу
            }

            if ((whereami5!=2)&&(whereami6!=2)&&(whereami5!=3)&&(whereami6!=3)) { // Если нет стен то можно бежать
                man.setPosition(px-=1, py);
                man.nextFrame();
                man.setTransform(Sprite.TRANS_NONE);
            }

        }
        if (((keyStates & RIGHT_PRESSED) != 0)&&(waid!=3)&&(py%8==0)) { // Выход за пределы лестницы только по блокам 8*8
            whereami5=bg.getCell((px+8)/8, py/8);
            whereami6=bg.getCell((px+8)/8, (py+7)/8);
            if ((waid!=1)&&(waid!=4)) {
                man.setFrameSequence(frameSequenceRun);
                waid = 1; // Я бегу
            }
            if ((whereami5!=2)&&(whereami6!=2)&&(whereami5!=3)&&(whereami6!=3)) { // Если нет стен то можно бежать
                man.setPosition(px+=1, py);
                man.nextFrame();
                man.setTransform(Sprite.TRANS_MIRROR);
            }
        }
    }
    private void verifyGameState() {
		if (((whereami3==1)&&(whereami4==1)||(whereami3==5&&whereami4==5))  // Я падаю если подо мной небо или веревка
		&&(bg.getCell(px/8, py/8)+bg.getCell((px+7)/8, py/8)+whereami+whereami2<20)) {
			    if (waid!=3) {
                man.setFrameSequence(frameSequenceFly);
                waid=3;
            }
            py+=1;
			man.setPosition(px, py);
        }
		if ((py%8==0)&&((bg.getCell(px/8, py/8)==5)||(bg.getCell((px+7)/8, py/8)==5))) {
            if (waid!=4) {
                man.setFrameSequence(frameSequenceClimb);
                waid=4; // Я ползу по веревке
            }
        }
        if ((waid==3)&&((whereami3==2)||(whereami3==3)||(whereami3==4)||(whereami4==2)||(whereami4==3)||(whereami4==4)))
            waid=0; // Я остановился после полёта, под нами почва;
    }
    private void createBg() {
        int[] cells = {
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 5, 5, 5, 5, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 2, 2, 2, 4, 2, 2, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 4, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1,
            1, 4, 2, 2, 3, 3, 3, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 5, 5, 5, 1, 1, 1, 1, 4, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 4, 2, 2, 2, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 3, 3, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 3, 1, 3, 3, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 2, 2, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 5, 5, 5, 5, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 2, 2, 2, 4, 2, 2, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 1, 4, 1, 1, 1, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 4, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1,
            1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1,
            1, 4, 2, 2, 3, 3, 3, 2, 2, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 5, 5, 5, 1, 1, 1, 1, 4, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 4, 2, 2, 2, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 4, 4, 4, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 3, 3, 1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            1, 4, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 3, 1, 3, 3, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
            2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 2, 2, 1, 1, 4, 1, 1, 1, 1, 1
        };
        for (int i = 0; i < cells.length; i++) {
            int column = i % 30;
            int row = (i - column) / 30;
            bg.setCell(column, row, cells[i]);
        }

        // устанавливаем место размещения фона
        bg.setPosition(0, 0);
    }

    protected void readLevel(byte stage) {
        InputStream is;
        int chars;
        int i = 0;


        try {
            is = getClass().getResourceAsStream(stage+".map");
            while ((chars = is.read()) != -1) {
                if ((chars>48) && (chars<54)) {   // От 1 до 5 кодируются элементы карты
                    int col = i % 30;
                    int lin = (i - col) / 30;
                    bg.setCell(col, lin, chars-48);
                    i++;
                }
            }
            is.close();
        } catch (IOException e) { }
        finally {
            is = null;
        }
        // устанавливаем место размещения фона
        bg.setPosition(0, 0);
    }
}

